#!/usr/bin/python
############################################################################# 
#   Simple Silly Printer                                           Ver 0.1  #
#                                                                           # 
#   This program is just a stupid little piece in code to demonstrate some  #
#   of the elementary features of python. It is a bit of an excuse to play  #
#   with some of the fundamental data structures.                           #
#                                                                           #
#  This file has bunch of useful output functions.                          #
#                                                                           #
#  Author: Dylan A. Shell                                                   #
#                                                                           #
############################################################################# 

import time 
import sys

def print_with_delay(s):
    # Print one character at a time
    for i in range(len(s)):    
        print s[i]+"",
        sys.stdout.flush()
        time.sleep(0.1)

def pretty_suffix(n):
    # Given an integer, return a string with the appropriate 'st','nd','rd','th'
    assert(isinstance(n,int))
    s = '%s' % n # Turn into string
    if s[-1] == '1': # Is last character a 1?
        return 'st'
    elif s[-1] == '2': # Nope, is it a 2?
        return 'nd'
    elif s[-1] == '3': # How about a 3?
        return 'rd'
    return 'th' # Everything else is a 'th'

def pretty_suffix2(n):
    # Given an integer, return a string with the appropriate 'st','nd','rd','th'
    assert(isinstance(n,int))
    l = n%10
    if l == 1: 
        return 'st'
    elif l == 2: 
        return 'nd'
    elif l == 3: 
        return 'rd'
    return 'th'

def pretty_suffix3(n):
    # Given an integer, return a string with the appropriate 'st','nd','rd','th'
    assert(isinstance(n,int))
    special_suffx = {0:'th', 1:'st', 2:'nd', 3:'rd'} # define a dictionary for quick lookup
    l = n%10
    if l > 3: 
        l = 0
    return special_suffx[l] 
   



