#!/usr/bin/python
############################################################################# 
#   Simple Silly Printer                                           Ver 0.1  #
#                                                                           # 
#   This program is just a stupid little piece in code to demonstrate some  #
#   of the elementary features of python. It is a bit of an excuse to play  #
#   with some of the fundamental data structures.                           #
#                                                                           #
#  This file does all the heavy lifting.                                    #
#                                                                           #
#  Author: Dylan A. Shell                                                   #
#                                                                           #
############################################################################# 

import time  # We use this library to allow us to put in delays
import sys   # We use sys to let us flush the output
import ex4_printing # Get our own miscellaneous 


def main(): # Main entry into the program

    # Declare the variables we have
    my_capacity = 5

    print 'I\'m Hungry'

    n = -1  # Set to an initially infeasible value
    while n <= 0:
        inp = raw_input('How many pies are there? ')
        try: 
            n = int(inp)
            if n <= 0:
                print "Number of pies must be a non-negative integer"
        except ValueError:
            print "The number of pies must be a NUMBER!"
        
    print ""

    eaten = 0
    delay = 0.3
    for i in range(0,n):    
        print 'Eating %d%s pie' % (i+1, ex4_printing.pretty_suffix3(i+1))
        time.sleep(delay)
        delay += 0.2 # Start to slow down.
        if  i == my_capacity-1:
            print 'Gonna explode!'

        if  i > my_capacity-1:
            print 'Exploded!\n\n'
            print 'Pie ',
            ex4_printing.print_with_delay('EVERYWHERE!!!')
            break


if __name__ == "__main__":
    main()
